function flagExternalLinks() {

    $.getJSON('/assets/get-domains', function (domains) {

        hostname = new RegExp(location.host);

        var allowed_domains = [];

        $.each(domains, function (key, val) {
            if (typeof val !== 'undefined') {
                allowed_domains.push(val);
            }
        });

        window.allowed_domains = allowed_domains;

        $('a').each(function (i, v) {

            var url = $(v).attr("href");

            if (
                (typeof url != 'undefined'
                && (
                    url.toLowerCase().indexOf('http') == 0
                    || url.toLowerCase().indexOf('https') == 0
                )
                && url.slice(0, 1) != "#"
                && hostname.test(url) !== true
                && checkValidDomain(url, allowed_domains) !== true)
                || url === '#login-option'
            ) {
                $(v).addClass('external-link-warning')
                    .attr('data-toggle', 'modal')
                    .attr('data-target', '#external-link-warning')
                    .attr('data-url', url)
                    .attr('href', '#');
                // Do we need to pass the UTM params?
                maybeAddUTM(v);
            }
        });
    });

}

function checkValidDomain(_domain, _allowed) {

    for (i = 0; i < _allowed.length; i++) {

        if (_allowed[i] != '' && _domain.toLowerCase().indexOf(_allowed[i]) != -1) {
            return true;
        }
    }

    return false;
}

const utmTargetUrls = [
    "https://open.qcbt.com",
    "https://open.communitybt.bank",
    "https://open.crbt.bank",
    "https://open.gbankmo.com",
    "https://open.bankcsb.com"
];

function pass_utm( target_url ) {
    // Get the current URL
    var currentUrl = new URL(window.location.href);

    // Get UTM parameters
    var utmSource = currentUrl.searchParams.get("utm_source");
    var utmMedium = currentUrl.searchParams.get("utm_medium");
    var utmCampaign = currentUrl.searchParams.get("utm_campaign");

    // Create a new URL object
    var newUrl = new URL(target_url);

    // Get the search parameters of the new URL
    var params = newUrl.searchParams;

    // Append UTM parameters to the new URL
    if (utmSource) params.set("utm_source", utmSource);
    if (utmMedium) params.set("utm_medium", utmMedium);
    if (utmCampaign) params.set("utm_campaign", utmCampaign);

    // Set the search parameters of the new URL
    newUrl.search = params.toString();

    return newUrl.toString();
}

function maybeAddUTM( element ) {
    var targetUrl = element.getAttribute('data-url');
    if (!targetUrl) {
        return;
    }
    var isMatchingUrl = utmTargetUrls.some(url => targetUrl.startsWith(url));
    if (isMatchingUrl) {
        element.setAttribute('data-url', pass_utm(targetUrl));
    }
}

(function (window, document) {

    setTimeout(function () {
        flagExternalLinks();
    }, 500);

})(window, document);



$('#external-link-warning').on('show.bs.modal', function (event) {

    $('a#external-link-button').attr('href', event.relatedTarget.dataset.url);
    $('a#external-link-button').attr('target', event.relatedTarget.dataset.target);
});

$('a#external-link-button').click(function () {
    $('#external-link-warning').modal('hide');
});
